/*

   SD card attached to SPI bus as follows:
 ** MOSI - pin 11
 ** MISO - pin 12
 ** CLK - pin 13
 ** CS - pin 10 (for MKRZero SD: SDCARD_SS_PIN)

  Code reads robot position and writes it to SD card.

*/
#include <SPI.h>
#include <SD.h>
#include <robot.h>

File dance1;

void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  robotActivate();     //let the robot know commands are comming
  robotMode(manual);   //set the robot to manual control

  Serial.print("Initializing SD card...");

  if (!SD.begin(10)) {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");

  /*optional code.  Uncomment code below to prompt before removing file
    Serial.println("remove dance1.txt?");
    while (!Serial.available());
    while (Serial.read() != 'y');
    SD.remove("dance1.txt");
  */

  dance1 = SD.open("dance1.txt", FILE_WRITE);  //opens the file and prepares to write
  Serial.println("three");
  delay(1000);
  Serial.println("two");
  delay(1000);
  Serial.println("one");
  delay(1000);
  Serial.println("go!!!");  //Warn user that recording is coming

}

void loop() {
  long timer1 = millis();    //immportatnt to use LONG here to match type of millis()


  while ((millis() - timer1) < 159000) {
    if ((millis() - timer1) > (159000 - 1000)) Serial.println("one");
    else if ((millis() - timer1) > (159000 - 2000)) Serial.println("two");
    else if ((millis() - timer1) > (159000 - 3000)) Serial.println("three");

    long timer2 = millis();

    //record value o 255 twice.  
    //This is not likely to occur in the data nad makes a good start marker.
    dance1.write(0xFF);
    dance1.write(0xFF);
    //Record each channel in turn.
    dance1.write(robotPosition(1));  
    dance1.write(robotPosition(2));
    dance1.write(robotPosition(3));
    dance1.write(gripperPosition());

    /*
      dance1.write(0xFF);
      dance1.write(0xFF);
      dance1.write(x++);
      Serial.println(millis()-timer1);
    */
    while ((millis() - timer2) < 30);  //wait until 30 milliseconds have past

  }
  dance1.close();
  Serial.println("done");
  while(true);   //We're done.  Wait here forever.

}

